<template>
  <div class="w-[21rem] text-white">
    <div class="ml-5 pb-1 text-xl font-bold">{{ label }}</div>
    <div class="w-full relative">

      <input @input="checkInput" :placeholder="placeholder" :type="hiddenType"
        :value="modelValue"
        class="box-border bg-gray-700 relative text-white w-full h-12 px-4 py-2 rounded-3xl border-blue-300 text-xl focus:border-2 focus:outline-none focus:border-yellow-300"
        :class="{ 'border-2': errorMessage, 'border': !errorMessage, 'border-red-500': errorMessage, 'pr-12': eye }" />
      <div class="h-full grid content-center absolute bottom-0 right-3">
        <font-awesome-icon @click.prevent.stop="toggleVisibility" :icon="eyeIcon" size="lg"
          v-if="eye" class="text-center p-1 hover:cursor-pointer" />
      </div>
    </div>
    <div class="h-6 ml-5 mt-1 text-red-500">{{ errorMessage }}</div>
  </div>
</template>

<script>

export default {
  props: {
    label: String,
    validators: Array,
    placeholder: String,
    eye: Boolean,
    hidden: Boolean,
    modelValue: String
  },
  emits: ['update:modelValue', 'error'],
  data() {
    return {
      errorMessage: "",
      eyeIcon: "eye",
      hiddenType: '',
      eyeIconMap: new Map([
        [true, 'eye'],
        [false, 'eye-slash']
      ])
    }
  },
  methods: {
    checkInput(inputEvent) {
      const value = inputEvent.target.value
      this.$emit('update:modelValue', value)

      for (let i = 0; i < this.validators.length; i++) {
        const validator = this.validators[i]
        const error = validator(value)
        if (error) {
          this.errorMessage = error
          this.$emit('error', true)
          return
        }
      }
      this.$emit('error', false)
      this.errorMessage = ""
    },
    toggleVisibility() {
      if (this.eyeIcon == this.eyeIconMap.get(true)) {
        this.hiddenType = 'password'
        this.eyeIcon = this.eyeIconMap.get(false)
      }
      else {
        this.hiddenType = ''
        this.eyeIcon = this.eyeIconMap.get(true)
      }
    }
  },
  mounted() {
    if (this.hidden)
      this.toggleVisibility()
  }
}

</script>